/*-------------------------------------------------------------------------
File name   : dlxChecker.e
Title       : CPU Data and Temporal Checker Implementation
Project     : DLX Validation
Developer   : Prabhat Mishra
Created     : 09-02-2003
Description : Temporal checker - Fetch1 signal should be asserted 1 cycle 
            : after entering execution state.
            : Data Checker - When instruction execution is done, compare 
            : register values in DUT to expected values from reference model
---------------------------------------------------------------------------
Copyright 2004 (c) Regents of University of California, Irvine
-------------------------------------------------------------------------*/

<'
import dlxDrive;

extend cpu_env_s {

    event exec_done is ((sys.time == 10) and true('top.rst'==0));

    on_exec_done() is {
        // Compare PC - program counter
		if (sys.dut.pc != sys.refmodel.pc) then {
			out(sys.dut.pc, " ", sys.refmodel.pc, " ", sys.time);
			dut_error("DATA MISMATCH(Program Counter)");
        };

		// Compare contents of register file
		check that sys.dut.R == sys.refmodel.regs else
			dut_error("DATA MISMATCH(Register File)");
   };
};
'>
