/*-------------------------------------------------------------------------
File name   : dlxCover.e
Title       : CPU Functional Coverage Implementation
Project     : DLX Validation
Developer   : Prabhat Mishra
Created     : 08-29-2003
Description : This module defines the Functional Coverage cover points.  
---------------------------------------------------------------------------
Copyright 2004 (c) Regents of University of California, Irvine
-------------------------------------------------------------------------*/

<'
import dlxDrive; 

extend cpu_instr_s {
    cover start_drv_DUT is {
		item opcode;
		item instType;
    }; 
};
'>

<'
extend R_type cpu_instr_s {
    cover start_drv_DUT is also {
		item rdest: cpu_reg_t = dest;
		item rsrc1: cpu_reg_t = src1;
		item rsrc2: cpu_reg_t = src2;
		cross opcode, rdest;
		cross opcode, rsrc1;
		cross opcode, rsrc2;
    }; 
};
extend I_type cpu_instr_s {
    cover start_drv_DUT is also {
		item idest: cpu_reg_t = dest;
		item isrc1: cpu_reg_t = src1;
		cross opcode, idest;
		cross opcode, isrc1;
    }; 
};
'>

<'
extend cpu_dut_s {
    cover functional_coverage is {
		item fstall: bool = FET.stall;
		item dstall: bool = DEC.stall;
		item istall: bool = EXE.INT.stall;
		item f1stall: bool = EXE.FLT.F1.stall;
		item f2stall: bool = EXE.FLT.F2.stall;
		item f3stall: bool = EXE.FLT.F3.stall;
		item f4stall: bool = EXE.FLT.F4.stall;
		item m1stall: bool = EXE.MUL.M1.stall;
		item m2stall: bool = EXE.MUL.M2.stall;
		item m3stall: bool = EXE.MUL.M3.stall;
		item m4stall: bool = EXE.MUL.M4.stall;
		item m5stall: bool = EXE.MUL.M5.stall;
		item m6stall: bool = EXE.MUL.M6.stall;
		item m7stall: bool = EXE.MUL.M7.stall;
		item vstall: bool = EXE.DIV.stall;
		item mstall: bool = MEM.stall;
	//	item wstall: bool = WBK.stall;
		
	//	item fbusy: bool = FET.busy;
	//	item dbusy: bool = DEC.busy;
	//	item ibusy: bool = EXE.INT.busy;
	//	item f1busy: bool = EXE.FLT.F1.busy;
	//	item f2busy: bool = EXE.FLT.F2.busy;
	//	item f3busy: bool = EXE.FLT.F3.busy;
	//	item f4busy: bool = EXE.FLT.F4.busy;
	//	item m1busy: bool = EXE.MUL.M1.busy;
	//	item m2busy: bool = EXE.MUL.M2.busy;
	//	item m3busy: bool = EXE.MUL.M3.busy;
	//	item m4busy: bool = EXE.MUL.M4.busy;
	//	item m5busy: bool = EXE.MUL.M5.busy;
	//	item m6busy: bool = EXE.MUL.M6.busy;
	//	item m7busy: bool = EXE.MUL.M7.busy;
	//	item vbusy: bool = EXE.DIV.busy;
	//	item mbusy: bool = MEM.busy;
	//	item wbusy: bool = WBK.busy;
		
		item fflush: bool = FET.flush;
		item dflush: bool = DEC.flush;
		item iflush: bool = EXE.INT.flush;
		item f1flush: bool = EXE.FLT.F1.flush;
		item f2flush: bool = EXE.FLT.F2.flush;
		item f3flush: bool = EXE.FLT.F3.flush;
		item f4flush: bool = EXE.FLT.F4.flush;
		item m1flush: bool = EXE.MUL.M1.flush;
		item m2flush: bool = EXE.MUL.M2.flush;
		item m3flush: bool = EXE.MUL.M3.flush;
		item m4flush: bool = EXE.MUL.M4.flush;
		item m5flush: bool = EXE.MUL.M5.flush;
		item m6flush: bool = EXE.MUL.M6.flush;
		item m7flush: bool = EXE.MUL.M7.flush;
		item vflush: bool = EXE.DIV.flush;
		item mflush: bool = MEM.flush;
	//	item wflush: bool = WBK.flush;

		item fexception: bool = FET.exception;
		item dexception: bool = DEC.exception;
		item iexception: bool = EXE.INT.exception;
		item f1exception: bool = EXE.FLT.F1.exception;
		item f2exception: bool = EXE.FLT.F2.exception;
		item f3exception: bool = EXE.FLT.F3.exception;
		item f4exception: bool = EXE.FLT.F4.exception;
		item m1exception: bool = EXE.MUL.M1.exception;
		item m2exception: bool = EXE.MUL.M2.exception;
		item m3exception: bool = EXE.MUL.M3.exception;
		item m4exception: bool = EXE.MUL.M4.exception;
		item m5exception: bool = EXE.MUL.M5.exception;
		item m6exception: bool = EXE.MUL.M6.exception;
		item m7exception: bool = EXE.MUL.M7.exception;
		item vexception: bool = EXE.DIV.exception;
		item mexception: bool = MEM.exception;
		item wexception: bool = WBK.exception;
    }; 
};
'>
